 /***************************************************************
 * Name:      Mon_Book.cpp
 * Purpose:   Code for the NoteBook class
 * Author:    Jackie Team (jackie.team@gmail.com)
 * Created:   2007-11-26
 * Copyright: Jackie Team (http://musicorganizer.free.fr)
 * License: GNU GPL
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "components.h"
#include <fileref.h>
#include <tag.h>
#include <id3v1tag.h>
#include <id3v2tag.h>
#include <id3v2framefactory.h>
#include <mpegfile.h>


BEGIN_EVENT_TABLE(MonBook, wxNotebook)
    EVT_BUTTON(ID_SAVE,MonBook::button_click)
    EVT_BUTTON(ID_SAVE2,MonBook::button_clickV1)
    EVT_BUTTON(ID_COPIER,MonBook::btnCopyClick)
    EVT_BUTTON(ID_DEPLACER,MonBook::btnMoveClick)
    EVT_BUTTON(ID_APPERCU,MonBook::btnApercuRename)
    EVT_BUTTON(ID_ANNULER,MonBook::btnAnnulerClick)
    EVT_BUTTON(ID_VALIDER,MonBook::btnValiderClick)
    EVT_BUTTON(ID_V1TOV2,MonBook::v1ToV2)
    EVT_BUTTON(ID_V2TOV1,MonBook::v2ToV1)
    //EVT_BUTTON(ID_CLEAN,MonBook::btnCleanID3v2Click)
    EVT_TEXT(ID_COMBOORG,MonBook::textWriting)
    EVT_TEXT(ID_FIC,MonBook::textWriting2)
    EVT_TEXT(ID_ANNEE,MonBook::textWritingNumbers)
    EVT_TEXT(ID_TRACK,MonBook::textWritingNumbers2)
    EVT_MENU(ID_THREAD,MonBook::cpyMoveThreadMsg)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(wxModalFrame,wxFrame)
    EVT_CLOSE ( wxModalFrame::onClose )
END_EVENT_TABLE()

wxModalFrame::wxModalFrame(wxWindow* parent, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size, long style, const wxString& name) : wxFrame(parent,id,title,pos,size,style,name){
    parent->GetGrandParent()->Disable();
}

void wxModalFrame::onClose(wxCloseEvent &event){
    GetParent()->GetGrandParent()->Enable();
    Destroy();
}

/***********************************************************************************/

MonBook::MonBook(wxWindow* parent) : wxNotebook(parent,-1)
{
        panelPage1 = new wxPanel(this);
        panelPage2 = new wxPanel(this);
        panelPage3 = new wxPanel(this);
        //panelPage4 = new wxPanel(this);
        wxPanel* panGauche = new wxPanel(panelPage1);
        wxPanel* panDroite = new wxPanel(panelPage1);
        wxBoxSizer* sizerPage1 = new wxBoxSizer(wxHORIZONTAL);

        AddPage(panelPage1, _("Tags"));
        AddPage(panelPage2, _("Organize"));
        AddPage(panelPage3, _("Rename"));
        //AddPage(panelPage4, _T("Copie"));
        //panelPage1.default=("");
        //Interieur de la page 1
        //id3v2
        wxStaticBox* gpBoxID3v2 = new wxStaticBox(panDroite, wxID_ANY, _T("ID3v2"),wxPoint(0,0));
        
        new wxStaticText(panDroite, wxID_ANY, _("Title"), wxPoint(15,24));
        comboTitre = new ComboBox(panDroite, wxID_ANY,_T(""), wxPoint(70,20), wxSize(200,18),wxArrayString(1,_T("")));
        new wxStaticText(panDroite, wxID_ANY, _("Artist"), wxPoint(15,49));
        comboInterprete = new ComboBox(panDroite, wxID_ANY,_T(""), wxPoint(70,45), wxSize(200,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Album"), wxPoint(15,74));
        comboAlbum = new ComboBox(panDroite, wxID_ANY,_T(""), wxPoint(70,70), wxSize(200,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Year"), wxPoint(15,99));
        comboAnne = new ComboBox(panDroite, ID_ANNEE,_T(""), wxPoint(70,95), wxSize(70,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Track"), wxPoint(165,99));
        comboPiste = new ComboBox(panDroite, ID_TRACK,_T(""), wxPoint(200,95), wxSize(70,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panDroite, wxID_ANY, _("Genre"), wxPoint(15,124));
        comboGenre = new ComboBox(panDroite, wxID_ANY,_T(""), wxPoint(70,120), wxSize(200,18),wxArrayString(1,_T("")),wxCB_SORT);
        wxImage* disq=new wxImage();
        disq->AddHandler(new wxPNGHandler());
        disq->LoadFile(_T("disquette.png"));
        
        //the buttons
        button_save = new wxBitmapButton(panDroite, ID_SAVE, wxBitmap (*disq), wxPoint(300,15),wxSize(30,31));
        //btnCleanID3V2 = new wxButton(panDroite, ID_CLEAN, _T("Nettoyer les tags"), wxPoint(300,110),wxSize(110,30));
        
        //id3v1
        wxStaticBox* gpBoxID3v1 = new wxStaticBox(panGauche, wxID_ANY, _T("ID3v1"),wxPoint(0,0),wxSize(350,160));
        
        new wxStaticText(panGauche, wxID_ANY, _("Title"), wxPoint(15,24));
        comboTitre2 = new ComboBox(panGauche, wxID_ANY,_T(""), wxPoint(70,20), wxSize(200,18),wxArrayString(1,_T("")));
        new wxStaticText(panGauche, wxID_ANY, _("Artist"), wxPoint(15,49));
        comboInterprete2 = new ComboBox(panGauche, wxID_ANY,_T(""), wxPoint(70,45), wxSize(200,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Album"), wxPoint(15,74));
        comboAlbum2 = new ComboBox(panGauche, wxID_ANY,_T(""), wxPoint(70,70), wxSize(200,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Year"), wxPoint(15,99));
        comboAnne2 = new ComboBox(panGauche, ID_ANNEE,_T(""), wxPoint(70,95), wxSize(70,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Track"), wxPoint(165,99));
        comboPiste2 = new ComboBox(panGauche, ID_TRACK,_T(""), wxPoint(200,95), wxSize(70,18),wxArrayString(1,_T("")),wxCB_SORT);
        new wxStaticText(panGauche, wxID_ANY, _("Genre"), wxPoint(15,124));
        comboGenre2 = new ComboBox(panGauche, wxID_ANY,_T(""), wxPoint(70,120), wxSize(200,18),wxArrayString(1,_T("")),wxCB_SORT);
        button_save2=new wxBitmapButton(panGauche, ID_SAVE2, wxBitmap (*disq), wxPoint(300,15),wxSize(30,31));
        wxGridSizer* sizerPanDroite = new wxGridSizer(1);
        sizerPanDroite->Add(gpBoxID3v2,0, wxEXPAND|wxALL);
        panDroite->SetSizer(sizerPanDroite);
        sizerPage1->Add(panGauche,0, wxEXPAND|wxALL);
        sizerPage1->Add(10,1);
        sizerPage1->Add(panDroite,1, wxEXPAND|wxALL);
        panelPage1->SetSizer(sizerPage1);

        //Interieur de la page 2
        wxPanel* panOrg = new wxPanel(panelPage2);
        wxPanel* panOrgLegende = new wxPanel(panelPage2);
        wxStaticBox* gpBoxOrganisation = new wxStaticBox(panOrg, wxID_ANY, _("Organization"),wxPoint(0,0),wxSize(550,160));
        wxStaticBox* gpBoxOrgLegende = new wxStaticBox(panOrgLegende, wxID_ANY, _("Caption"),wxPoint(0,0));
        wxGridSizer* sizerLegende = new wxGridSizer(1);
        wxBoxSizer* sizerPage2 = new wxBoxSizer(wxHORIZONTAL);
        
        new wxStaticText(panOrg, wxID_ANY, _("File organization's description:"), wxPoint(15,15));
        comboOrg = new wxComboBox(panOrg, ID_COMBOORG,_T(""), wxPoint(15,35), wxSize(500,18)); //Combobox de choix d'organisation des fichiers
        comboOrg->Append(_T("%1/%2"));
        comboOrg->Append(_T("%4/%1"));
        comboOrg->Append(_T("%4/%1/%2"));
        comboOrg->Append(_T("%3/%4"));
        comboOrg->Append(_T("%3/%4/%1"));
        comboOrg->Append(_T("%3/%4/%1/%2"));
        btnCopier = new wxButton(panOrg, ID_COPIER, _("Copy to..."), wxPoint(397,70),wxSize(120,30)); //Bouton "Copier dans..."
        btnDeplacer = new wxButton(panOrg, ID_DEPLACER, _("Move to..."), wxPoint(397,110),wxSize(120,30)); //Bouton "Dï¿œplacer dans..."
        new wxStaticText(panOrg, wxID_ANY, _("Keyboarding preview:"), wxPoint(15,60),wxSize(350,15),wxST_NO_AUTORESIZE|wxALIGN_CENTRE);
        DescrSaisie = new wxTextCtrl(panOrg, wxID_ANY, _T(""), wxPoint(15,80),wxSize(350,60),wxTE_MULTILINE|wxST_NO_AUTORESIZE|wxALIGN_CENTRE|wxTE_BESTWRAP|wxTE_READONLY);
        DescrSaisie->SetBackgroundColour(wxColour(247,247,247));
        infoSaisie = new wxStaticText(panOrgLegende, wxID_ANY, _("%1 : Artist\n%2 : Album\n%3 : Year\n%4 : Genre"), wxPoint(15,15));
        sizerLegende->Add(gpBoxOrgLegende,0, wxEXPAND|wxALL);
        panOrgLegende->SetSizer(sizerLegende);
        sizerPage2->Add(panOrg,0, wxEXPAND|wxALL);
        sizerPage2->Add(10,1);
        sizerPage2->Add(panOrgLegende,1, wxEXPAND|wxALL);
        panelPage2->SetSizer(sizerPage2);


        //Interieur de la page 3
        wxPanel* panRen = new wxPanel(panelPage3);
        wxPanel* panRenLegende = new wxPanel(panelPage3);
        wxStaticBox* gpBoxRen = new wxStaticBox(panRen, wxID_ANY, _("Rename"),wxPoint(0,0),wxSize(550,160));
        wxStaticBox* gpBoxRenLegende = new wxStaticBox(panRenLegende, wxID_ANY, _("Caption"),wxPoint(0,0));
        wxGridSizer* sizerRenLegende = new wxGridSizer(1);
        wxBoxSizer* sizerPage3 = new wxBoxSizer(wxHORIZONTAL);
        
        new wxStaticText(panRen, wxID_ANY, _("Files' name"), wxPoint(15,15));
        comboNomFic = new wxComboBox(panRen, ID_FIC,_T(""), wxPoint(15,35), wxSize(500,18));
        comboNomFic->Append(_T("%2 - %1"));
        comboNomFic->Append(_T("%5 - %1"));
        new wxStaticText(panRen, wxID_ANY, _("Track format:"), wxPoint(390,70));
        comboFormatPiste = new wxComboBox(panRen, ID_FIC,_T(""), wxPoint(465,67), wxSize(50,18),wxArrayString(0,_T("")),wxCB_READONLY);
        comboFormatPiste->Append(_T("0"));
        comboFormatPiste->Append(_T("00"));
        comboFormatPiste->Append(_T("000"));
        comboFormatPiste->SetValue(_T("00"));
        new wxStaticText(panRenLegende, wxID_ANY, _("%1 : Title \n%2 : Artist \n%3 : Album \n%4 : Year \n%5 : Track \n%6 : Genre"), wxPoint(15,15));;
        btnApercu = new wxButton(panRen, ID_APPERCU, _("Preview"), wxPoint(387,105),wxSize(130,35));
        new wxStaticText(panRen, wxID_ANY, _("Keyboarding preview:"), wxPoint(15,60),wxSize(350,15),wxST_NO_AUTORESIZE|wxALIGN_CENTRE);
        DescrSaisie2 = new wxTextCtrl(panRen, wxID_ANY, _T(""), wxPoint(15,80),wxSize(350,60),wxTE_MULTILINE|wxST_NO_AUTORESIZE|wxTE_BESTWRAP|wxALIGN_CENTRE|wxTE_READONLY);
        DescrSaisie2->SetBackgroundColour(wxColour(247,247,247));
        sizerRenLegende->Add(gpBoxRenLegende,0, wxEXPAND|wxALL);
        panRenLegende->SetSizer(sizerRenLegende);
        sizerPage3->Add(panRen,0, wxEXPAND|wxALL);
        sizerPage3->Add(10,1);
        sizerPage3->Add(panRenLegende,1, wxEXPAND|wxALL);
        panelPage3->SetSizer(sizerPage3);

        /*Interieur de la page 4
        wxStaticBox* box = new wxStaticBox(panelPage4, wxID_ANY, _T("Options"),wxPoint(0,0));
        
        chkTitre = new wxCheckBox(panelPage4, wxID_ANY, _T("Titre"), wxPoint(15,25));
        chkArtiste = new wxCheckBox(panelPage4, wxID_ANY, _T("Artiste"), wxPoint(115,25));
        chkGenre = new wxCheckBox(panelPage4, wxID_ANY, _T("Genre"), wxPoint(215,25));
        chkAlbum = new wxCheckBox(panelPage4, wxID_ANY, _T("Album"), wxPoint(315,25));
        chkAnne = new wxCheckBox(panelPage4, wxID_ANY, _T("Annee"), wxPoint(415,25));
        chkPiste = new wxCheckBox(panelPage4, wxID_ANY, _T("Piste"), wxPoint(515,25));
        chkNoEmpty = new wxCheckBox(panelPage4, wxID_ANY, _T("Copier meme si la source est vide"), wxPoint(15,50));
        
        wxGridSizer* sizerGroupBox = new wxGridSizer(1);
        sizerGroupBox->Add(box,0, wxEXPAND|wxALL);
        panelPage4->SetSizer(sizerGroupBox);*/
        
        //On initialise les genres et les annÃ©es
        for (int i=0 ; i<=125 ; i++){
            comboGenre->Append(GENRES[i]);
            comboGenre2->Append(GENRES[i]);
        }
        for (int i=0 ; i<=201 ; i++){
            comboAnne->Append(wxString::Format(_T("%d"),1850 +i));
            comboAnne2->Append(wxString::Format(_T("%d"),1850 +i));
        }
        //p=parent;
        lstComboTitre = new wxArrayString();
        lstComboInterprete = new wxArrayString();
        lstComboAlbum = new wxArrayString();
        lstComboPiste = new wxArrayString();
        lstComboTitre2 = new wxArrayString();
        lstComboInterprete2 = new wxArrayString();
        lstComboAlbum2 = new wxArrayString();
        lstComboPiste2 = new wxArrayString();


}

void MonBook::setListe(wxListCtrl* l){
    liste=l;
}

void MonBook::setArbo(wxGenericDirCtrl* a){
    arbo=a;
}


void MonBook::button_click(wxCommandEvent& event){
    if(liste->GetSelectedItemCount()==0)
        return;
    //Les changements ne pouvant pas etre annules, on previent l'utilisateur
    wxMessageDialog dlg_info(NULL,_("Save changes?"),_("Warning!"), wxICON_EXCLAMATION | wxYES_NO);
    int res=dlg_info.ShowModal();
    dlg_info.Destroy();

    if (res==wxID_NO)
      return ;
    MaListe* l=(MaListe*)liste;
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<liste->GetSelectedItemCount() ; i++){
       currentSel= l->getSelection(AncienneSel);
       wxString currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,SEPARATOR);
       TagLib::ID3v2::FrameFactory* ff=TagLib::ID3v2::FrameFactory::instance();
       ff->setDefaultTextEncoding(TagLib::String::UTF8);
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
       fic.setID3v2FrameFactory(ff);


        if(comboTitre->GetValue()!=_("<Title>") ){
            TagLib::String s((char const*)comboTitre->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v2Tag(true)->setTitle(s);
            l->SetItem(currentSel,MaListe::TITLE_COL,comboTitre->GetValue());
        }

        if(comboInterprete->GetValue()!=_("<Artist>") ){
            TagLib::String s((char const*)comboInterprete->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v2Tag(true)->setArtist(s);
            l->SetItem(currentSel,MaListe::ARTIST_COL,comboInterprete->GetValue());
        }

        if(comboAlbum->GetValue()!=_("<Album>") ){
            TagLib::String s((char const*)comboAlbum->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v2Tag(true)->setAlbum(s);
            l->SetItem(currentSel,MaListe::ALBUM_COL,comboAlbum->GetValue());
        }

        if(comboAnne->GetValue()!=_("<Year>") ){
            try{
                long y;
                comboAnne->GetValue().ToLong(&y);
                fic.ID3v2Tag(true)->setYear((int)y);
            }catch(...){
            }
            l->SetItem(currentSel,MaListe::YEAR_COL,comboAnne->GetValue());
        }

        if(comboPiste->GetValue()!=_("<Track>") ){
            try{
                long t;
                comboPiste->GetValue().ToLong(&t);
                fic.ID3v2Tag(true)->setTrack((int)t);
            }catch(...){
            }
            l->SetItem(currentSel,MaListe::TRACK_COL,comboPiste->GetValue());
        }

        if(comboGenre->GetValue()!=_("<Genre>") ){
            TagLib::String s((char const*)comboGenre->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v2Tag(true)->setGenre(s);
            l->SetItem(currentSel,MaListe::GENRE_COL,comboGenre->GetValue());
        }

        fic.save(TagLib::MPEG::File::ID3v2,false);//On ne sauvegarde que les ID3v2
        AncienneSel = currentSel;

    }

}

void MonBook::button_clickV1(wxCommandEvent& event){
    if(liste->GetSelectedItemCount()==0)
        return;
    //Les changements ne pouvant pas etre annules, on previent l'utilisateur
    wxMessageDialog dlg_info(NULL,_("Save changes?"),_("Warning!"), wxICON_EXCLAMATION | wxYES_NO);
    int res=dlg_info.ShowModal();
    dlg_info.Destroy();

    if (res==wxID_NO)
      return ;
    MaListe* l=(MaListe*)liste;
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<liste->GetSelectedItemCount() ; i++){
       currentSel = l->getSelection(AncienneSel);
       wxString currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
       wxString currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
       wxString dir;
       dir.Printf(currentDir+wxT("%c")+currentName,SEPARATOR);
       TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);

        if(comboTitre2->GetValue()!=_("<Title>") ){
            TagLib::String t((char const*)comboTitre2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v1Tag(true)->setTitle(t);
            l->getTitreV1Sorted()->Item(currentSel)=comboTitre2->GetValue();
        }

        if(comboInterprete2->GetValue()!=_("<Artist>") ){
            TagLib::String s((char const*)comboInterprete2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v1Tag(true)->setArtist(s);
            l->getArtisteV1Sorted()->Item(currentSel)=comboInterprete2->GetValue();
        }

        if(comboAlbum2->GetValue()!=_("<Album>") ){
            TagLib::String s((char const*)comboAlbum2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v1Tag(true)->setAlbum(s);
            l->getAlbumV1Sorted()->Item(currentSel)=comboAlbum2->GetValue();
        }


        if(comboAnne2->GetValue()!=_("<Year>") ){
            try{
                long y;
                comboAnne2->GetValue().ToLong(&y);
                fic.ID3v1Tag(true)->setYear((int)y);
            }catch(...){
            }
            l->getAnneeV1Sorted()->Item(currentSel)=comboAnne2->GetValue();
        }


        if(comboPiste2->GetValue()!=_("<Track>") ){
            try{
                long t;
                comboPiste2->GetValue().ToLong(&t);
                fic.ID3v1Tag(true)->setTrack((int)t);
            }catch(...){
            }
            l->getPisteV1Sorted()->Item(currentSel)=comboPiste2->GetValue();
        }


        if(comboGenre2->GetValue()!=_("<Genre>") ){
            TagLib::String s((char const*)comboGenre2->GetValue().mb_str(wxConvUTF8),TagLib::String::UTF8);
            fic.ID3v1Tag(true)->setGenre(s);
            l->getGenreV1()->Item(currentSel)=comboGenre2->GetValue();
        }

        fic.save(TagLib::MPEG::File::ID3v1,false);//On ne sauvegarde que les ID3v1
        AncienneSel = currentSel;

    }

}

void MonBook::cleanStr(wxString& str,wxString& replace){

    wxRegEx eexp(wxT("[\xE8\xE9\xEA\xEB]"));
    wxRegEx euexp(wxT("[\xC8\xC9\xCA\xCB]"));
    wxRegEx aexp(wxT("[\xE0\xE1\xE2\xE3\xE4\xE5]"));
    wxRegEx auexp(wxT("[\xC0\xC1\xC2\xC3\xC4\xC5]"));
    wxRegEx iexp(wxT("[\xEC\xED\xEE\xEF]"));
    wxRegEx iuexp(wxT("[\xCC\xCD\xCE\xCF]"));
    wxRegEx oexp(wxT("[\xF2\xF3\xF4\xF5\xF6]"));
    wxRegEx ouexp(wxT("[\xD2\xD3\xD4\xD5\xD6]"));
    wxRegEx uexp(wxT("[\xF9\xFA\xFB\xFC]"));
    wxRegEx uuexp(wxT("[\xD9\xDA\xDB\xDC]"));
    wxRegEx invalid_chars(wxT("[^a-zA-Z0-9/ ().,;_&-]"));

    eexp.Replace(&str,wxString(_T("e")),0);
    euexp.Replace(&str,wxString(_T("E")),0);
    aexp.Replace(&str,wxString(_T("a")),0);
    auexp.Replace(&str,wxString(_T("A")),0);
    iexp.Replace(&str,wxString(_T("i")),0);
    iuexp.Replace(&str,wxString(_T("I")),0);
    oexp.Replace(&str,wxString(_T("o")),0);
    ouexp.Replace(&str,wxString(_T("O")),0);
    uexp.Replace(&str,wxString(_T("u")),0);
    uuexp.Replace(&str,wxString(_T("U")),0);
    str.Replace(wxT("\xE7"),wxT("c"));
    str.Replace(wxT("\xC7"),wxT("C"));
    invalid_chars.Replace(&str,replace,0);
    str.Replace(_T("\0"),_T(""));


}

void MonBook::btnCopyClick(wxCommandEvent& event){
    MaListe* l=(MaListe*)liste;
    if( comboOrg->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
            wxDirDialog folder(this,_("Please choose a directory"));
            if(folder.ShowModal()==wxID_OK){
                //Recuperation du dossier dans lequel l'utilisateur desire organiser sa musique
                wxString dossier=folder.GetPath();
                wxString annee,album,artiste,genre;
                //Operation sur la saisie :
                // - On remplace les "%1", "%2", "%3", et "%4" par ce qui y correspond, pour chaque fichier selectionne
                progBar=new wxProgressDialog(_("Please wait"),_("Files are beeing copied..."),100,NULL,wxPD_AUTO_HIDE | wxPD_CAN_ABORT | wxPD_APP_MODAL);
                thread=new CopyMoveThread(liste,this,dossier);
                thread->Create();
                thread->Run();
            }
        }
    }
}

void MonBook::btnMoveClick(wxCommandEvent& event){
    MaListe* l=(MaListe*)liste;
    if( comboOrg->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
            wxDirDialog folder(this,_("Please choose a directory"));
            if(folder.ShowModal()==wxID_OK){
                //Recuperation du dossier dans lequel l'utilisateur dÃ©sire organiser sa musique
                wxString dossier=folder.GetPath();
                wxString annee,album,artiste,genre;
                //Operation sur la saisie :
                // - On remplace les "%1", "%2", "%3", et "%4" par ce qui y correspond, pour chaque fichier selectionne
                progBar=new wxProgressDialog(_T("Patientez"),_T("Deplacement des fichiers..."),100,NULL,wxPD_AUTO_HIDE | wxPD_CAN_ABORT | wxPD_APP_MODAL);
                thread=new CopyMoveThread(liste,this,dossier,true);
                thread->Create();
                thread->Run();

            }
        }
    }
}

wxString MonBook::ucwords(const wxString& s){
    wxStringTokenizer tkz(s,wxT("\t\r\n "),wxTOKEN_RET_DELIMS);//split la chaine sur le caractï¿œre '/'
    wxString res;
    while(tkz.HasMoreTokens() ){
        wxString token = tkz.GetNextToken();
        res+=token.Mid(0,1).MakeUpper()+token.Mid(1);
    }
    return res;

}

void MonBook::btnApercuRename(wxCommandEvent& event){
    MaListe* l=(MaListe*)liste;
    if( comboNomFic->GetValue()!=_T("")){
        if( l->GetSelectedItemCount()==0){
            wxMessageDialog msg(NULL,_("No files selected!"), _("Unable to perform task"),wxICON_EXCLAMATION|wxOK);
            msg.ShowModal();
        }else{
                wxString annee,album,artiste,genre;
                //Operation sur la saisie :
                // - On remplace les "%1", "%2", "%3", et "%4" par ce qui y correspond, pour chaque fichier selectionne
                int h=0;
                listeNoms.Clear();
                listeNoms2.Clear();
                wxArrayString listeAnciensNoms;
                wxArrayString listeNouveauxNoms;
                long AncienneSel = l->getSelection(-2);
                for (h=0 ; h<l->GetSelectedItemCount() ; h++){
                    wxString artiste = l->getSelRowText(MaListe::ARTIST_COL,AncienneSel);
                    wxString titre = l->getSelRowText(MaListe::TITLE_COL,AncienneSel);
                    wxString album = l->getSelRowText(MaListe::ALBUM_COL,AncienneSel);
                    wxString annee = l->getSelRowText(MaListe::YEAR_COL,AncienneSel);
                    wxString genre = l->getSelRowText(MaListe::GENRE_COL,AncienneSel);
                    wxString piste = l->getSelRowText(MaListe::TRACK_COL,AncienneSel);
                    wxString SaisieStr,dir,currentName,currentDir;
                    artiste.Replace(_T("/"),_T("_"));
                    album.Replace(_T("/"),_T("_"));
                    annee.Replace(_T("/"),_T("_"));
                    genre.Replace(_T("/"),_T("_"));
                    titre.Replace(_T("/"),_T("_"));
                    piste.Replace(_T("/"),_T("_"));
                    SaisieStr = comboNomFic->GetValue();
                    SaisieStr.Replace(_T("%1"), titre.Trim());
                    SaisieStr.Replace(_T("%2"), artiste.Trim());
                    SaisieStr.Replace(_T("%3"), album.Trim());
                    SaisieStr.Replace(_T("%4"), annee.Trim());
                    long numPiste;
                    piste.ToLong(&numPiste);
                    wxString format = _T("%02d");
                    if(comboFormatPiste->GetValue() == _T("0")){
                          format = _T("%01d");
                    }else if(comboFormatPiste->GetValue() == _T("000")){
                          format = _T("%03d");
                    }
                    SaisieStr.Replace(_T("%5"), wxString::Format(format,numPiste));   
                    SaisieStr.Replace(_T("%6"), genre.Trim());
                    
                    wxString rchar=OptionsHandler::getOption(_T("replace_char"));
                    if(rchar==_T(""))
                        rchar=_T("_");
                    SaisieStr.Replace(_T("\""),rchar);
	                cleanStr(SaisieStr,rchar);
                    currentDir=l->getSelRowText(MaListe::DIR_COL,AncienneSel);
                    currentName=l->getSelRowText(MaListe::NAME_COL,AncienneSel);
                    dir.Printf(currentDir+wxT("%c")+currentName,SEPARATOR);
                    //On recupere son extension pour la rajoutee
                    wxString ext = currentName.Mid(currentName.Find(_T('.'),true)+1);
                    wxString newName = SaisieStr;
                    newName = wxString::Format(newName + _T("%c") + ext,_T('.'));

                    listeAnciensNoms.Add(currentName);
                    listeNouveauxNoms.Add(newName);
                    newName.Printf(l->getSelRowText(MaListe::DIR_COL,AncienneSel)+_T("%c")+newName,SEPARATOR);
                    listeNoms.Add(dir);
                    listeNoms2.Add(newName);

                    AncienneSel = l->getSelection(AncienneSel);
                }
                containList = new wxModalFrame(this, wxID_ANY, _("Rename"), wxPoint(200,200), wxSize(800,600),wxDEFAULT_FRAME_STYLE|wxFRAME_FLOAT_ON_PARENT);
                containList->SetBackgroundColour(wxColour(230,230,230));
                //On crÃ©e la liste  (munie de CheckBoxs)
                LstBox=new wxCheckListCtrl(containList);

                //On crÃ©e les bouton "valider" et "annuler" et on les placent dans le fenetre
                wxBoxSizer* sizer3=new wxBoxSizer(wxHORIZONTAL);
                wxBoxSizer* sizer4=new wxBoxSizer(wxVERTICAL);
                btnAnnuler = new wxButton(containList,ID_ANNULER,_("Cancel"));
                btnValider = new wxButton(containList,ID_VALIDER,_("OK"));
                sizer4->Add(LstBox,1, wxALL|wxEXPAND);
                sizer3->Add(btnValider,0);
                sizer3->Add(8,0,0);
                sizer3->Add(btnAnnuler,0,wxALL|wxEXPAND);
                sizer3->Add(8,0,0);
                sizer4->Add(0,8,0);
                sizer4->Add(sizer3,0,wxALIGN_RIGHT|wxALIGN_BOTTOM);
                sizer4->Add(0,8,0);
                containList->SetSizer(sizer4);
                containList->Show();
                //On insere tout ce qui est nÃÂ©cessaire dans la liste
                //Et l'on coche ce qu'il faut
                long int k = 0;
                AncienneSel = l->getSelection(-2);
                for (k=0 ;k<listeAnciensNoms.GetCount();k++){
                    LstBox->InsertItem(k,listeAnciensNoms.Item(k));
                    LstBox->SetItem(k,1,listeNouveauxNoms.Item(k));
                    LstBox->SetIcon(k,0);
                    wxString cur = comboNomFic->GetValue();
                    if (cur.Find(_T("%1")) != wxNOT_FOUND){
                        if (l->getSelRowText(1,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%2")) != wxNOT_FOUND){
                        if (l->getSelRowText(2,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%3")) != wxNOT_FOUND){
                        if (l->getSelRowText(3,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%4")) != wxNOT_FOUND){
                        if (l->getSelRowText(4,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%5")) != wxNOT_FOUND){
                        if (l->getSelRowText(6,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    if (cur.Find(_T("%6")) != wxNOT_FOUND){
                        if (l->getSelRowText(5,AncienneSel) == _T("")){
                            LstBox->SetIcon(k,1);
                            LstBox->SetItemBackgroundColour(k,wxColour(220,170,170));
                        }
                    }
                    
                }


            }
        }

}

void MonBook::textWriting(wxCommandEvent& event){
    wxString s = comboOrg->GetValue();
    if (s == _T(""))
        DescrSaisie->SetLabel(_T(""));
    if (s.Find(_T('\\')) != wxNOT_FOUND or s.Find (_T(':')) != wxNOT_FOUND or s.Find (_T('*')) != wxNOT_FOUND or s.Find (_T('?')) != wxNOT_FOUND or s.Find (_T('\"')) != -1 or s.Find (_T('<')) != -1 or s.Find (_T('>')) != -1 or s.Find (_T('|')) != wxNOT_FOUND){         
        comboOrg->SetValue(text1);
        comboOrg->SetInsertionPointEnd();
        s = text1;
    }else{
        text1 = s;
    }
    s.Replace(_T("%1"), _("<Artist>"));
    s.Replace(_T("%2"), _("<Album>"));
    s.Replace(_T("%3"), _("<Year>"));
    s.Replace(_T("%4"), _("<Genre>"));
    DescrSaisie->SetValue(s);

}

void MonBook::textWriting2(wxCommandEvent& event){
    wxString s = comboNomFic->GetValue();
    if (s == _T(""))
        DescrSaisie->SetLabel(_T(""));
    if (s.Find(_T('/')) != wxNOT_FOUND or s.Find(_T('\\')) != wxNOT_FOUND or s.Find (_T(':')) != wxNOT_FOUND or s.Find (_T('*')) != wxNOT_FOUND or s.Find (_T('?')) != wxNOT_FOUND or s.Find (_T('\"')) != -1 or s.Find (_T('<')) != -1 or s.Find (_T('>')) != -1 or s.Find (_T('|')) != wxNOT_FOUND){
        comboNomFic->SetValue(text2);
        comboNomFic->SetInsertionPointEnd();
        s = text2;
    }else{
        text2 = s;
    }
    s.Replace(_T("%1"), _("<Title>"));
    s.Replace(_T("%2"), _("<Artist>"));
    s.Replace(_T("%3"), _("<Album>"));
    s.Replace(_T("%4"), _("<Year>"));
    s.Replace(_T("%5"), _("<Track>"));
    s.Replace(_T("%6"), _("<Genre>"));
    DescrSaisie2->SetValue(s);
}

void MonBook::textWritingNumbers2(wxCommandEvent& event){
    wxString s = comboPiste->GetValue();
    long offset=0;
#ifdef __WXMSW__
    offset=1;
#else
    if(s.Length()==0)
        offset=1;
#endif
    if (not s.IsNumber())
        comboPiste->Remove(comboPiste->GetLastPosition() - offset,comboPiste->GetLastPosition()-offset+1);
    else{
        long len;
        s.ToLong(&len);
        if (len > 9999)
            comboPiste->Remove(comboPiste->GetLastPosition() -offset,comboPiste->GetLastPosition()-offset+1);
    }

}

void MonBook::textWritingNumbers(wxCommandEvent& event){
    wxString s = comboAnne->GetValue();
    long offset=0;
#ifdef __WXMSW__
    offset=1;
#else
    if(s.Length()==0)
        offset=1;
#endif
    if (not s.IsNumber())
        comboAnne->Remove(comboAnne->GetLastPosition()- offset,comboAnne->GetLastPosition()-offset+1);
    else{
        long len;
        s.ToLong(&len);
        if (len > 9999)
            comboAnne->Remove(comboAnne->GetLastPosition() -offset,comboAnne->GetLastPosition()-offset+1);
    }

}

void MonBook::btnAnnulerClick(wxCommandEvent& event){
    containList->Close();
}

void MonBook::btnValiderClick(wxCommandEvent& event){
    int h=0;
    MaListe *l=(MaListe*)liste;
    long AncienneSel = l->getSelection(-1);
    wxString n;
    wxListItem i;
    i.SetMask(wxLIST_MASK_TEXT);
    i.SetColumn(1);
    for (h=0 ; h<LstBox->GetItemCount();h++){
        if (LstBox->IsChecked((long)h)){
            try{
                wxRenameFile(listeNoms[h],listeNoms2[h]);
                LstBox->SetItem(h,2,_("<OK>"));
                i.SetId(h);
                LstBox->GetItem(i);
                n=i.GetText();
                l->SetItem(AncienneSel,0,n);
            }catch(...){
                LstBox->SetItem(h,2,_("<ERROR>"));
            }
        }
        AncienneSel = l->getSelection(AncienneSel);
    }
    btnAnnuler->SetLabel(_("Close"));
    btnValider->Destroy();
}

void MonBook::cpyMoveThreadMsg(wxCommandEvent& event){
    int type=event.GetInt();
    if(type==-1){//mise Ã  jour de la progBar
        progBar->Update(thread->getProg());
    }else{
        progBar->Destroy();
        if (type != 0){
            if (type == 1){
                wxMessageDialog msg(NULL,_("1 error while performing task"), _("Error"),wxICON_HAND|wxOK);
                msg.ShowModal();
            }else{
                wxString err=wxString::Format(_T("%d"),type);
                wxMessageDialog msg(NULL,err + _(" errors while performing task"), _("Error"),wxICON_HAND|wxOK);
                msg.ShowModal();
            }
        }
        
        MonArbo* ma = (MonArbo*)arbo;
        ma->refresh();
    }
}

void MonBook::v1ToV2(wxCommandEvent& event){
    comboAlbum->SetValue(comboAlbum2->GetValue());
    comboTitre->SetValue(comboTitre2->GetValue());
    comboInterprete->SetValue(comboInterprete2->GetValue());
    comboAnne->SetValue(comboAnne2->GetValue());
    comboGenre->SetValue(comboGenre2->GetValue());
    comboPiste->SetValue(comboPiste2->GetValue());
}

void MonBook::v2ToV1(wxCommandEvent& event){
    comboAlbum2->SetValue(comboAlbum->GetValue());
    comboTitre2->SetValue(comboTitre->GetValue());
    comboInterprete2->SetValue(comboInterprete->GetValue());
    comboAnne2->SetValue(comboAnne->GetValue());
    comboGenre2->SetValue(comboGenre->GetValue());
    comboPiste2->SetValue(comboPiste->GetValue());
}

/*void MonBook::btnCleanID3v2Click(wxCommandEvent& event){
    if(liste->GetSelectedItemCount()==0)
        return;
    MaListe* l=(MaListe*)liste;
    long AncienneSel = l->getSelection(-2);
    long currentSel;
    for(unsigned int i=0 ; i<liste->GetSelectedItemCount() ; i++){
        currentSel = l->getSelection(AncienneSel);
        wxString currentDir=l->getSelRowText(8,AncienneSel);
        wxString currentName=l->getSelRowText(0,AncienneSel);
        wxString dir;
        dir.Printf(currentDir+wxT("%c")+currentName,SEPARATOR);
        TagLib::MPEG::File fic((char const*)dir.mb_str(*wxConvCurrent),true,TagLib::AudioProperties::Average);
        
        TagLib::String artist = fic.tag()->artist();
        TagLib::String titre = fic.tag()->title();
        TagLib::String album = fic.tag()->album();
        TagLib::String genre = fic.tag()->genre();
        
        wxString ar(artist.toCString(false),wxConvISO8859_1);
        wxString t(titre.toCString(false),wxConvISO8859_1);
        wxString al(album.toCString(false),wxConvISO8859_1);
        wxString g(genre.toCString(false),wxConvISO8859_1);
        
        ar.Replace(_T("\xFF"),_T(""));
        al.Replace(_T("\xFF"),_T(""));
        g.Replace(_T("\xFF"),_T(""));
        t.Replace(_T("\xFF"),_T(""));
        ar.Trim();
        al.Trim();
        g.Trim();
        t.Trim();
        
        artist = (char const*)ar.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setArtist(artist);
        
        titre = (char const*)t.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setTitle(titre);
        
        album = (char const*)al.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setAlbum(album);

        genre = (char const*)g.mb_str(*wxConvCurrent);
        fic.ID3v2Tag(true)->setGenre(genre);

        fic.save(TagLib::MPEG::File::ID3v2,false);//On ne sauvegarde que les ID3v2
        AncienneSel = currentSel;
    }
    wxMessageDialog dlg_fin(NULL,_T("Nettoyage reussi"),_T("Traitement accompli"), wxICON_INFORMATION | wxOK);
    dlg_fin.ShowModal();
}*/


