/***************************************************************
 * Name:      Music_Organizer__Main.h
 * Purpose:   Defines Application Frame
 * Author:    Jackie Team (jackie.team@gmail.com)
 * Created:   2007-11-26
 * Copyright: Jackie Team (http://musicorganizer.free.fr)
 * License:
 **************************************************************/

#ifndef MUSIC_ORGANIZER__MAIN_H
#define MUSIC_ORGANIZER__MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "Music_Organizer__App.h"
#include <wx/splitter.h>
#include <wx/splash.h>
#include <wx/icon.h>
#include <wx/aboutdlg.h>
#include <wx/hyperlink.h>
#include <wx/font.h>

#include "options_Dialog.h"
#include "components.h"

class Music_Organizer__Frame: public wxFrame
{
    public:
        Music_Organizer__Frame(wxFrame *frame, const wxString& title);
        ~Music_Organizer__Frame();
    private:
        enum
        {
            ID_REFRESH=13,
            ID_DEL,
            ID_SEL,
            idMenuRefresh=130,
            idMenuDel,
            idMenuSel,
            idMenuOp,
            idMenuQuit = 1000,
            idMenuAbout,
            idMenuHelp,
            ID_ANNULER=1758,
            ID_VALIDER,
            ID_MSG=7777
        };
        wxLocale m_locale;
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnHelp(wxCommandEvent& event);
        void onRefresh(wxCommandEvent& event);
        void onDel(wxCommandEvent& event);
        void onSel(wxCommandEvent& event);
        void onOp(wxCommandEvent& event);
        void onKeyUp(wxKeyEvent&);
        void changeMenu(wxCommandEvent& event);
        wxPanel* panel1;
        wxPanel* panel3;
        MonArbo* arbo;
        MonBook* tabControl;
        ListCtrlPanel* panel2;
        OptionsDialog* opd;
        wxMenu* editMenu;

        DECLARE_EVENT_TABLE()
};

#endif // MUSIC_ORGANIZER__MAIN_H
