/***************************************************************
 * Name:      checklistctrl.h
 * Purpose:   header for the listctrl with checkbox
 * Author:    Jackie Team (jackie.team@gmail.com)
 * Created:   2007-11-26
 * Copyright: Jackie Team (http://musicorganizer.free.fr)
 * License: GNU GPL
 **************************************************************/


#ifndef _WX_CHECKLISTCTRL_H_
#define _WX_CHECKLISTCTRL_H_

#include <wx/listctrl.h>
#include <wx/imaglist.h>
#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

	/*!
	 * wxCheckListCtrl
	 * The options hierarchy viewer.
	 */

	class wxCheckListCtrl: public wxListCtrl
	{
		DECLARE_CLASS(wxCheckListCtrl)
			public:
			wxCheckListCtrl(wxWindow* parent, wxWindowID id = wxID_ANY, const wxPoint& pt = wxDefaultPosition,
				const wxSize& sz = wxDefaultSize, long style = wxLC_REPORT);
			virtual ~wxCheckListCtrl();

			//// Event handlers
			void OnMouseEvent(wxMouseEvent& event);
			void OnKeyDown(wxKeyEvent& event);

			//// Accessors

			/*!
			*@brief Load the icons
			*/
			bool LoadIcons();

			/// Set the appropriate icon
			bool SetIcon(long& item,int=-1);

            /// Tell the state of item
			bool IsChecked(long item);

		protected:
			wxImageList*        m_imageList;

			DECLARE_EVENT_TABLE()
	};
#endif							 // _WB_CHECKLISTCTRL_H_
